Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.cs	(revision 13045)
@@ -21,275 +21,393 @@
 
 using System;
-using System.Collections.Generic;
+using System.ComponentModel;
 using System.Drawing;
 using System.Drawing.Drawing2D;
 using System.Drawing.Imaging;
+using System.Linq;
 using System.Windows.Forms;
 
 namespace HeuristicLab.Visualization {
   public partial class ChartControl : UserControl {
-    public Bitmap Bitmap { get; private set; }
-
-    private bool renderingRequired;
-    private Point buttonDownPoint;
-    private Point mousePosition;
-    private int mouseClickCount;
-
-    private Chart myChart;
-    public Chart Chart {
-      get { return myChart; }
+    public static readonly Cursor HandCursor = new Cursor(typeof(ChartControl), "Resources.Hand.cur");
+    public static readonly Cursor ZoomOutCursor = new Cursor(typeof(ChartControl), "Resources.ZoomOut.cur");
+    public static readonly Cursor ZoomInCursor = new Cursor(typeof(ChartControl), "Resources.ZoomIn.cur");
+
+    protected Bitmap Picture;
+    protected bool RenderingRequired;
+    protected Point ButtonDownPoint;
+    protected Point PreviousLocation;
+    protected int MouseClickCount;
+
+    protected bool SuppressEvents { get; set; }
+    private bool SuppressRender { get; set; }
+
+    private IChart chart;
+    public IChart Chart {
+      get { return chart; }
+      protected set {
+        if (chart != null) DeregisterChartEvents(chart);
+        chart = value;
+        chart.Enabled = Enabled;
+        pictureBox.Enabled = Enabled;
+        if (chart != null) RegisterChartEvents(chart);
+      }
+    }
+
+    private ChartMode mode;
+    public ChartMode Mode {
+      get { return mode; }
       set {
-        if (myChart != null) myChart.Update -= new EventHandler(myChart_Update);
-        myChart = value;
-        if (myChart != null) {
-          myChart.Update += new EventHandler(myChart_Update);
-          SetMode(Chart.Mode);
-        }
-        GenerateImage();
-      }
-    }
-    private bool myScaleOnResize;
-    public bool ScaleOnResize {
-      get { return myScaleOnResize; }
-      set { myScaleOnResize = value; }
-    }
-
-    public ChartControl() {
+        if (mode == value) return;
+        mode = value;
+        SetButtonCheckedSate();
+        SetPictureBoxCursor(GetPictureBoxCursor());
+        OnModeChanged();
+        if (chart != null) {
+          GenerateImage();
+        }
+      }
+    }
+
+    public bool ScaleOnResize { get; set; }
+
+    public bool IsRenderingPaused { get { return SuppressRender; } }
+
+    public ChartControl() : this(null) { }
+    public ChartControl(IChart defaultChart) {
       InitializeComponent();
-      myScaleOnResize = true;
+      ScaleOnResize = true;
+      Mode = ChartMode.Select;
+      Chart = defaultChart ?? new Chart(0, 0, Width, Height);
+    }
+
+    public void SuspendRendering() {
+      SuppressRender = true;
+    }
+
+    public void ResumeRendering() {
+      SuppressRender = false;
+      if (Chart != null) GenerateImage();
+    }
+
+    protected virtual void SetButtonCheckedSate() {
+      selectButton.Checked = false;
+      moveButton.Checked = false;
+      zoomInButton.Checked = false;
+      zoomOutButton.Checked = false;
+      if (mode == ChartMode.Select) selectButton.Checked = true;
+      else if (mode == ChartMode.Move) moveButton.Checked = true;
+      else if (mode == ChartMode.ZoomIn) zoomInButton.Checked = true;
+      else if (mode == ChartMode.ZoomOut) zoomOutButton.Checked = true;
+    }
+
+    protected virtual void SetPictureBoxCursor(Cursor cursor) {
+      if (pictureBox.Cursor != cursor) pictureBox.Cursor = cursor;
+    }
+
+    protected virtual Cursor GetPictureBoxCursor() {
+      if (Mode == ChartMode.Select)
+        return DefaultCursor;
+      if (Mode == ChartMode.Move)
+        return HandCursor;
+      if (Mode == ChartMode.ZoomIn)
+        return ZoomInCursor;
+      if (Mode == ChartMode.ZoomOut)
+        return ZoomOutCursor;
+      return null;
+    }
+
+    protected virtual void RegisterChartEvents(IChart chart) {
+      chart.RedrawRequired += ChartOnUpdateRequired;
+    }
+
+    protected virtual void DeregisterChartEvents(IChart chart) {
+      chart.RedrawRequired -= ChartOnUpdateRequired;
+    }
+
+    protected virtual void ChartOnUpdateRequired(object sender, EventArgs e) {
+      if (SuppressRender) return;
       GenerateImage();
     }
 
-    private void myChart_Update(object sender, EventArgs e) {
-      GenerateImage();
-    }
-    private void pictureBox_SizeChanged(object sender, EventArgs e) {
+    #region PictureBox Events
+    protected virtual void PictureBoxOnSizeChanged(object sender, EventArgs e) {
+      if (Chart == null) return;
       if (ScaleOnResize) {
         if ((pictureBox.Width > 0) && (pictureBox.Height > 0) && (Chart != null)) {
-          PointD point = Chart.TransformPixelToWorld(new Point(pictureBox.Width, Chart.SizeInPixels.Height - pictureBox.Height));
-          Chart.SetPosition(Chart.LowerLeft, point);
+          var point = Chart.TransformPixelToWorld(new Point(pictureBox.Width, Chart.SizeInPixels.Height - pictureBox.Height));
+          var diff = Chart.UpperRight - point;
+          Chart.SetPosition(new PointD(Chart.LowerLeft.X + (diff.DX / 2.0), Chart.LowerLeft.Y + (diff.DY / 2.0)),
+            new PointD(Chart.UpperRight.X - (diff.DX / 2.0), Chart.UpperRight.Y - (diff.DY / 2.0)));
         }
       }
       GenerateImage();
     }
-    private void pictureBox_VisibleChanged(object sender, EventArgs e) {
-      if (pictureBox.Visible && renderingRequired) {
-        GenerateImage();
-      }
-    }
-
-    private void pictureBox_MouseDown(object sender, MouseEventArgs e) {
-      buttonDownPoint = e.Location;
-      mouseClickCount = e.Clicks;
-    }
-    protected virtual void pictureBox_MouseUp(object sender, MouseEventArgs e) {
+
+    protected virtual void PictureBoxOnVisibleChanged(object sender, EventArgs e) {
+      if (pictureBox.Visible && RenderingRequired) GenerateImage();
+    }
+
+    protected virtual void PictureBoxOnMouseClick(object sender, MouseEventArgs e) {
+
+    }
+
+    protected virtual void PictureBoxOnMouseDoubleClick(object sender, MouseEventArgs e) {
+
+    }
+
+    protected virtual void OnKeyDown(object sender, KeyEventArgs e) {
+      if (Mode == ChartMode.Select) {
+        if (e.KeyCode == Keys.Delete) {
+          try {
+            SuspendRendering();
+            foreach (var primitive in Chart.Group.SelectedPrimitives)
+              Chart.Group.Remove(primitive);
+          } finally { ResumeRendering(); }
+        }
+      }
+    }
+
+    protected virtual void OnKeyUp(object sender, KeyEventArgs e) {
+
+    }
+
+    protected virtual void PictureBoxOnMouseWheel(object sender, MouseEventArgs e) {
+
+    }
+
+    protected virtual void PictureBoxOnMouseDown(object sender, MouseEventArgs e) {
+      if (Chart == null) return;
+      MouseClickCount = e.Clicks;
+      ButtonDownPoint = e.Location;
+      if (Mode != ChartMode.Select) return;
+
+      try {
+        SuspendRendering();
+        var worldLocation = Chart.TransformPixelToWorld(e.Location);
+        foreach (var sp in Chart.Group.SelectedPrimitives.Where(x => !x.ContainsPoint(worldLocation)))
+          sp.Selected = false;
+        var p = Chart.GetPrimitive(e.Location);
+        if (p != null) p.Selected = true;
+      } finally { ResumeRendering(); }
+    }
+
+    protected virtual void PictureBoxOnMouseUp(object sender, MouseEventArgs e) {
+      if (Chart == null) return;
       if (e.Button == MouseButtons.Left) {
-        if (Chart.Mode == ChartMode.Zoom) {
+        if (Mode == ChartMode.ZoomIn) {
+          //pictureBox.Refresh();
+          var lowerLeft = new Point(Math.Min(e.X, ButtonDownPoint.X), Math.Max(e.Y, ButtonDownPoint.Y));
+          var upperRight = new Point(Math.Max(e.X, ButtonDownPoint.X), Math.Min(e.Y, ButtonDownPoint.Y));
+          if ((lowerLeft.X != upperRight.X) && (lowerLeft.Y != upperRight.Y))
+            Chart.ZoomIn(lowerLeft, upperRight);
+          else Chart.ZoomIn(ButtonDownPoint);
+        } else if (Mode == ChartMode.ZoomOut) {
+          Chart.ZoomOut();
+        }
+      } else if (e.Button == MouseButtons.Right) {
+        propertiesToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count() == 1;
+        oneLayerUpToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count() == 1;
+        oneLayerDownToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count() == 1;
+        intoForegroundToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count() == 1;
+        intoBackgroundToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count() == 1;
+      } else if (e.Button == MouseButtons.Middle) {
+        if (Mode == ChartMode.Select) {
+          try {
+            SuspendRendering();
+            foreach (var p in Chart.Group.SelectedPrimitives)
+              p.Selected = false;
+          } finally { ResumeRendering(); }
+        } else if (Mode == ChartMode.Move || Mode == ChartMode.ZoomIn || Mode == ChartMode.ZoomOut) {
+          Chart.Unzoom();
+        }
+      }
+    }
+
+    protected virtual void PictureBoxOnMouseMove(object sender, MouseEventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<Object, MouseEventArgs>)PictureBoxOnMouseMove, sender, e);
+        return;
+      }
+      var toolTipText = Chart.GetToolTipText(e.Location);
+      if (toolTip.GetToolTip(pictureBox) != toolTipText) toolTip.SetToolTip(pictureBox, toolTipText);
+
+      Cursor cursor;
+      if (Mode == ChartMode.Select) {
+        cursor = Chart.GetCursor(e.Location) ?? GetPictureBoxCursor();
+      } else cursor = GetPictureBoxCursor();
+      SetPictureBoxCursor(cursor);
+
+      try {
+        if (e.Button == MouseButtons.None) return;
+
+        if (Mode == ChartMode.Select && e.Button == MouseButtons.Left) {
+          var previousWorldLocation = Chart.TransformPixelToWorld(PreviousLocation);
+          var worldLocation = Chart.TransformPixelToWorld(e.Location);
+          var offset = worldLocation - previousWorldLocation;
+          try {
+            SuspendRendering();
+            foreach (var primitive in Chart.Group.SelectedPrimitives.Where(p => p.ContainsPoint(previousWorldLocation)))
+              primitive.Move(previousWorldLocation, offset);
+          } finally { ResumeRendering(); }
+        } else if (Mode == ChartMode.Move) {
+          var previousWorldLocation = Chart.TransformPixelToWorld(PreviousLocation);
+          var worldLocation = Chart.TransformPixelToWorld(e.Location);
+          var offset = worldLocation - previousWorldLocation;
+          Chart.Move(new Offset(-1 * offset.DX, -1 * offset.DY));
+        } else if (Mode == ChartMode.ZoomIn && e.Button == MouseButtons.Left) {
           pictureBox.Refresh();
-          // some code to preserve the aspect ratio when zooming
-          //       +---------------------+ (Width,Height)
-          //       |  (x1,y1)            |
-          //       |      +-------+      |
-          //       |      |       |      | 
-          //       |      |       |      |
-          //       |      +-------+      |
-          //       |             (x2,y2) |
-          // (0,0) +---------------------+
-          // 
-          double aspectRatio = (double)Width / Height;
-          double x1 = Math.Min(e.X, buttonDownPoint.X);
-          double y1 = Math.Max(e.Y, buttonDownPoint.Y);
-          double x2 = Math.Max(e.X, buttonDownPoint.X);
-          double y2 = Math.Min(e.Y, buttonDownPoint.Y);
-          // consider the relative ratios between the X and Y dimensions of the selection 
-          // area and the Width and Height, respectively. The "dominant" dimension is the 
-          // one with a ratio closer to 1, and it stays fixed while the other is adjusted 
-          // in order to preserve the aspect ratio
-          if ((x2 - x1) / Width > (y1 - y2) / Height) {
-            y1 = y2 + (x2 - x1) / aspectRatio;
-          } else {
-            x2 = aspectRatio * (y1 - y2) + x1;
+          using (var graphics = pictureBox.CreateGraphics()) {
+            using (var pen = new Pen(Color.Gray) { DashStyle = DashStyle.Dash }) {
+              graphics.DrawRectangle(pen,
+                Math.Min(e.X, ButtonDownPoint.X),
+                Math.Min(e.Y, ButtonDownPoint.Y),
+                Math.Abs(e.X - ButtonDownPoint.X),
+                Math.Abs(e.Y - ButtonDownPoint.Y));
+            }
           }
-          var lowerLeft = new Point((int)x1, (int)y1);
-          var upperRight = new Point((int)x2, (int)y2);
-          if ((lowerLeft.X != upperRight.X) && (lowerLeft.Y != upperRight.Y)) {
-            Chart.ZoomIn(lowerLeft, upperRight);
+        }
+      } finally {
+        PreviousLocation = e.Location;
+        pictureBox.Update();
+      }
+    }
+
+    protected virtual void PictureBoxOnMouseEnter(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<Object, MouseEventArgs>)PictureBoxOnMouseEnter, sender, e);
+        return;
+      }
+      if (!Focused) this.pictureBox.Focus();
+    }
+
+    protected virtual void PictureBoxOnMouseLeave(object sender, EventArgs e) {
+
+    }
+
+    protected virtual void PictureBoxOnClick(object sender, EventArgs e) {
+      if (InvokeRequired) {
+        Invoke((Action<Object, MouseEventArgs>)PictureBoxOnClick, sender, e);
+        return;
+      }
+      if (!Focused) this.pictureBox.Focus();
+    }
+    #endregion
+
+    protected virtual void PictureBoxContextMenuStripOnOpening(object sender, CancelEventArgs e) { }
+
+    protected virtual void oneLayerUpToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Chart == null) return;
+      if (Chart.Group.SelectedPrimitives.Count() == 1) {
+        Chart.OneLayerUp(Chart.Group.SelectedPrimitives.First());
+      }
+    }
+    protected virtual void oneLayerDownToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Chart == null) return;
+      if (Chart.Group.SelectedPrimitives.Count() == 1) {
+        Chart.OneLayerDown(Chart.Group.SelectedPrimitives.First());
+      }
+    }
+    protected virtual void intoForegroundToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Chart == null) return;
+      if (Chart.Group.SelectedPrimitives.Count() == 1) {
+        Chart.IntoForeground(Chart.Group.SelectedPrimitives.First());
+      }
+    }
+    protected virtual void intoBackgroundToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Chart == null) return;
+      if (Chart.Group.SelectedPrimitives.Count() == 1) {
+        Chart.IntoBackground(Chart.Group.SelectedPrimitives.First());
+      }
+    }
+    protected virtual void propertiesToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Chart == null) return;
+      if (Chart.Group.SelectedPrimitives.Count() == 1) {
+        using (var dialog = new PropertiesDialog(Chart.Group.SelectedPrimitives.First())) {
+          dialog.ShowDialog(this);
+        }
+      }
+    }
+    protected virtual void saveImageToolStripMenuItem_Click(object sender, EventArgs e) {
+      if (Picture == null) return;
+
+      if (saveFileDialog.ShowDialog() == DialogResult.OK) {
+        var format = ImageFormat.Bmp;
+        var filename = saveFileDialog.FileName.ToLower();
+        if (filename.EndsWith("emf")) {
+          using (var g1 = Graphics.FromImage(Picture)) {
+            var rectangle = new System.Drawing.Rectangle(0, 0, Picture.Width, Picture.Height);
+            using (var metafile = new Metafile(filename, g1.GetHdc(), rectangle, MetafileFrameUnit.Pixel, EmfType.EmfPlusDual))
+            using (var g2 = Graphics.FromImage(metafile))
+              Chart.Render(g2, pictureBox.Width, pictureBox.Height);
           }
-        }
-      } else if (e.Button == MouseButtons.Right) {
-        propertiesToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count == 1;
-        oneLayerUpToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count == 1;
-        oneLayerDownToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count == 1;
-        intoForegroundToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count == 1;
-        intoBackgroundToolStripMenuItem.Enabled = Chart.Group.SelectedPrimitives.Count == 1;
-      } else if (e.Button == MouseButtons.Middle) {
-        if (Chart.Mode == ChartMode.Zoom) {
-          if (mouseClickCount == 1) Chart.ZoomOut();
-          else if (mouseClickCount == 2) Chart.Unzoom();
-        }
-      }
-      if (buttonDownPoint == e.Location) {
-        if (mouseClickCount == 1)
-          Chart.MouseClick(e.Location, e.Button);
-        else if (mouseClickCount == 2)
-          Chart.MouseDoubleClick(e.Location, e.Button);
-      }
-    }
-
-    protected virtual void pictureBox_MouseMove(object sender, MouseEventArgs e) {
-      var text = Chart.GetToolTipText(e.Location);
-      if (toolTip.GetToolTip(pictureBox) != text)
-        toolTip.SetToolTip(pictureBox, text);
-      Cursor cursor = Chart.GetCursor(e.Location);
-      if (cursor != null) pictureBox.Cursor = cursor;
-      else pictureBox.Cursor = Cursors.Default;
-
-      if (e.Button != MouseButtons.None) {
-        if ((Chart.Mode == ChartMode.Zoom) && (e.Button == MouseButtons.Left)) {
-          pictureBox.Refresh();
-          Graphics graphics = pictureBox.CreateGraphics();
-          Pen pen = new Pen(Color.Gray);
-          pen.DashStyle = DashStyle.Dash;
-          graphics.DrawRectangle(pen,
-                                 Math.Min(e.X, buttonDownPoint.X),
-                                 Math.Min(e.Y, buttonDownPoint.Y),
-                                 Math.Abs(e.X - buttonDownPoint.X),
-                                 Math.Abs(e.Y - buttonDownPoint.Y));
-          pen.Dispose();
-          graphics.Dispose();
-        }
-        Chart.MouseDrag(mousePosition, e.Location, e.Button);
-      } else {
-        Chart.MouseMove(mousePosition, e.Location);
-      }
-      mousePosition = e.Location;
-    }
-
-    protected virtual void pictureBox_MouseWheel(object sender, MouseEventArgs e) {
-      if (e.Delta > 0) {
-        // zoom in
-        double x1 = Chart.LowerLeft.X + Chart.Size.Width / 8;
-        double y1 = Chart.LowerLeft.Y + Chart.Size.Height / 8;
-        double x2 = Chart.UpperRight.X - Chart.Size.Width / 8;
-        double y2 = Chart.UpperRight.Y - Chart.Size.Height / 8;
-        Chart.ZoomIn(x1, y1, x2, y2);
-      } else if (e.Delta < 0) {
-        // zoom out
-        double x1 = Chart.LowerLeft.X - Chart.Size.Width / 8;
-        double y1 = Chart.LowerLeft.Y - Chart.Size.Height / 8;
-        double x2 = Chart.UpperRight.X + Chart.Size.Width / 8;
-        double y2 = Chart.UpperRight.Y + Chart.Size.Height / 8;
-        Chart.ZoomIn(x1, y1, x2, y2);
-      }
-    }
-
-    private void pictureBox_MouseEnter(object sender, EventArgs e) {
-      pictureBox.Focus();
-    }
-
-    protected virtual void ChartControl_KeyDown(object sender, KeyEventArgs e) {
-      if (Chart.Mode == ChartMode.Select) {
-        if (e.KeyCode == Keys.Delete) {
-          IList<IPrimitive> selected = Chart.Group.SelectedPrimitives;
-          Chart.UpdateEnabled = false;
-          foreach (IPrimitive primitive in selected)
-            Chart.Group.Remove(primitive);
-          Chart.UpdateEnabled = true;
-          Chart.EnforceUpdate();
-        }
-      }
-    }
-
-    private void moveToolStripMenuItem_Click(object sender, EventArgs e) {
-      SetMode(ChartMode.Move);
-    }
-    private void zoomToolStripMenuItem_Click(object sender, EventArgs e) {
-      SetMode(ChartMode.Zoom);
-    }
-    private void selectToolStripMenuItem_Click(object sender, EventArgs e) {
-      SetMode(ChartMode.Select);
-    }
-    private void oneLayerUpToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (Chart.Group.SelectedPrimitives.Count == 1) {
-        Chart.Group.SelectedPrimitives[0].OneLayerUp();
-      }
-    }
-    private void oneLayerDownToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (Chart.Group.SelectedPrimitives.Count == 1) {
-        Chart.Group.SelectedPrimitives[0].OneLayerDown();
-      }
-    }
-    private void intoForegroundToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (Chart.Group.SelectedPrimitives.Count == 1) {
-        Chart.Group.SelectedPrimitives[0].IntoForeground();
-      }
-    }
-    private void intoBackgroundToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (Chart.Group.SelectedPrimitives.Count == 1) {
-        Chart.Group.SelectedPrimitives[0].IntoBackground();
-      }
-    }
-    private void propertiesToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (Chart.Group.SelectedPrimitives.Count == 1) {
-        PropertiesDialog dialog = new PropertiesDialog(Chart.Group.SelectedPrimitives[0]);
-        dialog.ShowDialog(this);
-        dialog.Dispose();
-      }
-    }
-
-    private void GenerateImage() {
+        } else {
+          using (var graphics = Graphics.FromImage(Picture))
+            Chart.Render(graphics, Picture.Width, Picture.Height);
+
+          if (filename.EndsWith("jpg")) {
+            format = ImageFormat.Jpeg;
+          } else if (filename.EndsWith("gif")) {
+            format = ImageFormat.Gif;
+          } else if (filename.EndsWith("png")) {
+            format = ImageFormat.Png;
+          } else if (filename.EndsWith("tif")) {
+            format = ImageFormat.Tiff;
+          }
+
+          Picture.Save(saveFileDialog.FileName, format);
+        }
+      }
+    }
+
+    protected virtual void GenerateImage() {
+      if (InvokeRequired) {
+        Invoke((Action)GenerateImage);
+        return;
+      }
       if (!Visible) {
-        renderingRequired = true;
+        RenderingRequired = true;
       } else {
         if ((pictureBox.Width == 0) || (pictureBox.Height == 0)) {
-          Bitmap = null;
+          pictureBox.Image = pictureBox.ErrorImage;
+          if (Picture != null) Picture.Dispose();
+          Picture = null;
         } else {
-          Bitmap = new Bitmap(pictureBox.Width, pictureBox.Height);
-          if (Chart != null) {
-            Graphics graphics = Graphics.FromImage(Bitmap);
+          if (Picture != null) Picture.Dispose();
+          Picture = new Bitmap(pictureBox.Width, pictureBox.Height);
+          using (var graphics = Graphics.FromImage(Picture)) {
             graphics.SetClip(new System.Drawing.Rectangle(0, 0, pictureBox.Width, pictureBox.Height));
             Chart.Render(graphics, pictureBox.Width, pictureBox.Height);
-            graphics.Dispose();
           }
         }
-        if (pictureBox.Image != null) pictureBox.Image.Dispose();
-        pictureBox.Image = Bitmap;
-        renderingRequired = false;
-      }
-    }
-
-    private void SetMode(ChartMode mode) {
-      moveToolStripMenuItem.Checked = false;
-      zoomToolStripMenuItem.Checked = false;
-      selectToolStripMenuItem.Checked = false;
-      if (mode == ChartMode.Move) moveToolStripMenuItem.Checked = true;
-      else if (mode == ChartMode.Zoom) zoomToolStripMenuItem.Checked = true;
-      else if (mode == ChartMode.Select) selectToolStripMenuItem.Checked = true;
-      Chart.Mode = mode;
-    }
-
-    private void SaveImageAsBitmap(string filename) {
-      if (Bitmap == null) throw new Exception("Bitmap is null.");
-      Bitmap.Save(filename);
-    }
-
-    private void SaveImageAsEmf(string filename) {
-      using (Graphics g = CreateGraphics()) {
-        using (Metafile file = new Metafile(filename, g.GetHdc())) {
-          using (Graphics emfFile = Graphics.FromImage(file)) {
-            Chart.Render(emfFile, pictureBox.Width, pictureBox.Height);
-          }
-        }
-        g.ReleaseHdc();
-      }
-    }
-
-    private void saveImageToolStripMenuItem_Click(object sender, EventArgs e) {
-      if (saveFileDialog.ShowDialog() == DialogResult.OK) {
-        string filename = saveFileDialog.FileName.ToLower();
-        if (filename.EndsWith("bmp")) SaveImageAsBitmap(filename);
-        else if (filename.EndsWith("emf")) SaveImageAsEmf(filename);
-        else SaveImageAsBitmap(filename);
-      }
+        pictureBox.Image = Picture;
+        RenderingRequired = false;
+      }
+    }
+
+    public event EventHandler ModeChanged;
+    protected void OnModeChanged() {
+      var handler = ModeChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    protected virtual void SelectButtonOnCheckedChanged(object sender, EventArgs e) {
+      if (selectButton.Checked) Mode = ChartMode.Select;
+    }
+
+    protected virtual void MoveButtonOnCheckedChanged(object sender, EventArgs e) {
+      if (moveButton.Checked) Mode = ChartMode.Move;
+    }
+
+    protected virtual void ZoomInButtonOnCheckedChanged(object sender, EventArgs e) {
+      if (zoomInButton.Checked) Mode = ChartMode.ZoomIn;
+    }
+
+    protected virtual void ZoomOutButtonOnCheckedChanged(object sender, EventArgs e) {
+      if (zoomOutButton.Checked) Mode = ChartMode.ZoomOut;
+    }
+
+    private void ChartControl_Load(object sender, EventArgs e) {
+      if (!SuppressRender) GenerateImage();
     }
   }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartMode.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartMode.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartMode.cs	(revision 13045)
@@ -21,8 +21,11 @@
 
 namespace HeuristicLab.Visualization {
-  public enum ChartMode {
-    Move,
-    Zoom,
-    Select
+  public class ChartMode {
+    protected ChartMode() { }
+
+    public static readonly ChartMode Select = new ChartMode();
+    public static readonly ChartMode Move = new ChartMode();
+    public static readonly ChartMode ZoomIn = new ChartMode();
+    public static readonly ChartMode ZoomOut = new ChartMode();
   }
 }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/HeuristicLab.Visualization-3.3.csproj	(revision 13045)
@@ -104,6 +104,13 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
-      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    <Reference Include="HeuristicLab.Common.Resources-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common.Resources-3.3.dll</HintPath>
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="System" />
@@ -123,4 +130,10 @@
     <Compile Include="ChartMode.cs" />
     <Compile Include="AxisType.cs" />
+    <Compile Include="Primitives\Grid.cs" />
+    <Compile Include="Properties\Resources.Designer.cs">
+      <AutoGen>True</AutoGen>
+      <DesignTime>True</DesignTime>
+      <DependentUpon>Resources.resx</DependentUpon>
+    </Compile>
     <Compile Include="Trees\LayoutEngines\BoxesLayoutEngine.cs" />
     <Compile Include="Trees\LayoutEngines\ILayoutEngine.cs" />
@@ -131,4 +144,5 @@
     <None Include="Plugin.cs.frame" />
     <Compile Include="Plugin.cs" />
+    <Compile Include="Interfaces\IGrid.cs" />
     <Compile Include="Interfaces\IGroup.cs" />
     <Compile Include="Interfaces\IChart.cs" />
@@ -159,15 +173,10 @@
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="ChartControl.resx">
-      <DependentUpon>ChartControl.cs</DependentUpon>
-      <SubType>Designer</SubType>
+    <EmbeddedResource Include="Properties\Resources.resx">
+      <Generator>ResXFileCodeGenerator</Generator>
+      <LastGenOutput>Resources.Designer.cs</LastGenOutput>
     </EmbeddedResource>
-    <EmbeddedResource Include="PropertiesDialog.resx">
-      <DependentUpon>PropertiesDialog.cs</DependentUpon>
-      <SubType>Designer</SubType>
-    </EmbeddedResource>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="ClassDiagram.cd" />
+  </ItemGroup>
+  <ItemGroup>
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
@@ -190,4 +199,13 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Resources\Hand.cur" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Resources\ZoomIn.cur" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Resources\ZoomOut.cur" />
+  </ItemGroup>
   <Import Project="$(MSBuildBinPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
